% Author: Rayalejandro.lattarulo@tecnalia.com
% Coordinates of the route

figure(1)
hold on;
x = u(:,3); y = u(:,4);
plot(Xode(:,1),Xode(:,2),'r','Linewidth',0.8)
plot(xj(:,1),xj(:,2),'b','Linewidth',0.8)
plot(tau(:,2),tau(:,3),'g--','Linewidth',0.8)
xmin = min(x); xmax = max(x); ymin = min(y); ymax = max(y);
xlim([xmin-5 xmax+5]); ylim([ymin-5 ymax+5]);
xlabel('Coordinates X [m]','FontSize',12);
ylabel('Coordinates Y [m]','FontSize',12);
title('Theorical route and vehicle tracked route','FontSize',13);
legend('Closed loop simulation','Vehicle', 'Route');
clear x y xmin xmax ymin ymax;
hold off;

% figure Yaw rate
figure(2)
hold on;
plot(Tode,Xode(:,3),'r','Linewidth',0.8)
t = ((0:numel(xj(:,3))-1)*0.001)';
plot(t,xj(:,3),'b','Linewidth',0.8)
xlim([min(t) max(t)]);
xlabel('Time [sec]','FontSize',12);
ylabel('\psi [rad]','FontSize',12);
title('Yaw','FontSize',13);
legend('Closed loop simulation','Vehicle');
clear x y xmin xmax ymin ymax;
hold off;

% figure Yaw rate
figure(3)
hold on;
plot(Tode,Xode(:,4),'r','Linewidth',0.8)
t = ((0:numel(xj(:,4))-1)*0.001)';
plot(t,xj(:,4),'b','Linewidth',0.8)
xlim([min(t) max(t)]);
xlabel('Time [sec]','FontSize',12);
ylabel('V_X [m/s]','FontSize',12);
title('Longitudinal Speed','FontSize',13);
legend('Closed loop simulation','Vehicle');
clear x y xmin xmax ymin ymax;
hold off;


% figure Yaw rate
figure(4)
hold on;
plot(Tode,Xode(:,5),'r','Linewidth',0.8)
t = ((0:numel(xj(:,5))-1)*0.001)';
plot(t,xj(:,5),'b','Linewidth',0.8)
xlim([min(t) max(t)]);
xlabel('Time [sec]','FontSize',12);
ylabel('V_Y [m/s]','FontSize',12);
title('Lateral Speed','FontSize',13);
legend('Closed loop simulation','Vehicle');
clear x y xmin xmax ymin ymax;
hold off;

% figure Yaw rate
figure(5)
hold on;
plot(Tode,Xode(:,6),'r','Linewidth',0.8)
t = ((0:numel(xj(:,6))-1)*0.001)';
plot(t,xj(:,6),'b','Linewidth',0.8)
xlim([min(t) max(t)]);
xlabel('Time [sec]','FontSize',12);
ylabel('\omega [rad/s]','FontSize',12);
title('Yaw rate','FontSize',13);
legend('Closed loop simulation','Vehicle');
clear x y xmin xmax ymin ymax;
hold off;