% Author:   Rayalejandro.lattarulo@tecnalia.com      % Date: 21/03/2017
% Modified: Rayalejandro.lattarulo@tecnalia.com      % Date: 12/04/2017

% Setting the root path and cleaning the command window, Workspace and 
% closing the figures.
%cd 'E:\Ray Lattarulo\01_Proyectos\05 UnCoVerCPS\Codigos\2017_03_28 Tecnalia Scripts For Identification\2017_04_04 Scripts';
close all; clear variables; clc;
TRUE  = 1;
FALSE = 0;

% Modify this line>
ClosedLoop = TRUE;




basefolder = '';
% Configuration of the file
filenameXj  = 'JustFeedForward\DataVariable_oXj.csv';
filenameTau = 'JustFeedForward\DataVariable_oTau.csv';
if ClosedLoop == TRUE
    filenameXj  = 'FBAndFF\DataVariable_oXj.csv';
    filenameTau = 'FBAndFF\DataVariable_oTau.csv';
end
scriptname  = 'TECScript';
ts          = 0.001;
ts_rs       = 0.1;

% Get the data
xj = TECFunc_read_xj_csv(strcat(basefolder,filenameXj),1,1);
TECFunc_disp('Message',scriptname,'The variable Xj-Vehicle were read succesfully.');
u  = TECFunc_read_tau_csv(strcat(basefolder,filenameTau),1,1);
TECFunc_disp('Message',scriptname,'The variable U was read succesfully.');



% Get and Scale the data
[t,xj] = TECFunc_scale_xj(xj);
TECFunc_disp('Message',scriptname,'The variable Xj was scaled succesfully.');
u      = u;
TECFunc_disp('Message',scriptname,'The variable U was scaled succesfully.');


% Generation of the u-matrix from vector tau
u1= [];
i = 1;
while i <= numel(u(:,1))
    u1 = [u1;u(i,:)];
    i = i+ts_rs/ts;
end
x0 = zeros(15,1);
x0(1:6)  = xj(1,:)';
x0(3)    = 0.85*pi/2;
x0(9:15) = u(1,3:9)';
x0(11) = 0.85*pi/2;

dx0 = zeros(15,1);
Tode = 0;
Xode = xj(1,:);
time = [0:numel(u1(:,1))-1]';
tau  = [time u1(:,3:9)]; 
tau(1,4) = pi/2;
dxint = [];
%step through set-trajectory and simulate each segment
for i=1:numel(tau(:,1))-1;
    
    x0i = Xode(numel(Xode(:,1)),:)';
    t0i = Tode(end);
    x0i(9:15) = tau(i,2:8)';%[ID,Xs,Ys,PSIs,vs,kappas,dvsdt,dkappasds]
    t = t0i:ts_rs:tau(i+1,1)*ts_rs;

    if t(end)~=tau(i+1,1)*ts_rs;
        t(end) = tau(i+1,1)*ts_rs;
    end

    %simulate
    [Todei,Xodei]=ode45(@(t,x)vmodel_bicycle_lincontrol_ff(0,x,ClosedLoop),...
                        t,x0i);

    %%generate nominal controls
%     for j = 1:size(Xodei,1)
%         [dx,ax,delta] = vmodel_bicycle_lincontrol_ff(0,Xodei(j,:)',zeros(3,1));
%         Xodei(j,16:17) = [ax,delta];
%     end
%     dxint = [dxint; dx'];
    %append
    Tode = [Tode(1:end-1);Todei];
    Xode = [Xode(1:end-1,:);Xodei];
end
TECFunc_disp('Message',scriptname,'The closed loop simulation has finished.');
clear i;

% Plotting results
TECFunc_plotting();

% Delete additional variables
clear scriptname cutoffdata_speed filenameTau filenameXj originData;
% Delete constants values created
clear SIMULATION REALPLATFORM;